--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--								University of Hawaii at Manoa						         --
--						Instrumentation Development Lab / GARY S. VARNER				--
--   								Watanabe Hall Room 214								      --
--  								  2505 Correa Road										   --
--  								 Honolulu, HI 96822											--
--  								Lab: (808) 956-2920											--
--	 								Fax: (808) 956-2930										   --
--  						E-mail: idlab@phys.hawaii.edu									   --
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------	
-- Design by: Larry L. Ruckman Jr.															--
-- DATE : 22 OCT 2007																			--
-- Project name: BLAB1 firmware									 							--
--	Module name: BLAB1_TOP		  																--
--	Description : 																					--
-- 	Top level BLAB1 firmware																--
--		  											    												--
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity GCCINV_12BIT is
   port ( CNT  : in    std_logic_vector (11 downto 0); 
          HITT : out   std_logic_vector (11 downto 0));
end GCCINV_12BIT;

architecture Behavioral of GCCINV_12BIT is
   signal HIT  : std_logic_vector (11 downto 0);
   component BUF12
      port ( I : in    std_logic_vector (11 downto 0); 
             O : out   std_logic_vector (11 downto 0));
   end component;
	
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;	
	
	   component XOR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
	
begin

   XLXI_3 : BUF12
      port map (I(11 downto 0)=>HIT(11 downto 0),
                O(11 downto 0)=>HITT(11 downto 0));
   
   XLXI_112 : BUF
      port map (I=>CNT(0),
                O=>HIT(0));
   
   XLXI_124 : XOR2
      port map (I0=>HIT(2),
                I1=>CNT(1),
                O=>HIT(1));
   
   XLXI_125 : XOR2
      port map (I0=>HIT(3),
                I1=>CNT(2),
                O=>HIT(2));
   
   XLXI_126 : XOR2
      port map (I0=>HIT(4),
                I1=>CNT(3),
                O=>HIT(3));
   
   XLXI_127 : XOR2
      port map (I0=>HIT(5),
                I1=>CNT(4),
                O=>HIT(4));
   
   XLXI_128 : XOR2
      port map (I0=>HIT(6),
                I1=>CNT(5),
                O=>HIT(5));
   
   XLXI_129 : XOR2
      port map (I0=>HIT(7),
                I1=>CNT(6),
                O=>HIT(6));
   
   XLXI_130 : XOR2
      port map (I0=>HIT(8),
                I1=>CNT(7),
                O=>HIT(7));
   
   XLXI_131 : XOR2
      port map (I0=>HIT(9),
                I1=>CNT(8),
                O=>HIT(8));
   
   XLXI_132 : XOR2
      port map (I0=>HIT(10),
                I1=>CNT(9),
                O=>HIT(9));
   
   XLXI_133 : XOR2
      port map (I0=>HIT(11),
                I1=>CNT(10),
                O=>HIT(10));
   
   XLXI_134 : BUF
      port map (I=>CNT(11),
                O=>HIT(11));
   
end BEHAVIORAL;
